-- /packages/intranet-agile/sql/postgresql/intranet-agile-drop.sql
--
-- Copyright (c) 2003-2007 ]project-open[
--
-- All rights reserved. Please check
-- https://www.project-open.com/license/ for details.
--
-- @author frank.bergmann@project-open.com


-----------------------------------------------------
-- Drop menus and components defined by the module

select im_menu__del_module('intranet-agile');
select im_component_plugin__del_module('intranet-agile');

drop view if exists im_agile_scrum_status;
drop view if exists im_agile_kanban_status;

drop function if exists im_agile_task_rel__new (integer, varchar, integer, integer, integer, integer, varchar, integer, integer);
drop function if exists im_agile_task_rel__delete (integer);
drop function if exists im_agile_task_rel__delete (integer, integer);

drop table im_agile_task_rels;
delete from acs_rels where rel_type = 'im_agile_task_rel';
delete from acs_objects where object_type = 'im_agile_task_rel';
delete from im_rest_object_types where object_type = 'im_agile_task_rel';
select acs_rel_type__drop_type('im_agile_task_rel', true);


create or replace function inline_0 ()
returns integer as $body$
declare
	v_attrib_name		varchar;
	v_attrib_id		integer;
	v_count			integer;
begin
	v_attrib_name := 'agile_status_id';
	select	da.attribute_id into v_attrib_id
       	from	im_dynfield_attributes da,
		acs_attributes aa
	where	da.acs_attribute_id = aa.attribute_id and
		aa.attribute_name = v_attrib_name and
		aa.object_type = 'im_timesheet_task';
	IF v_attrib_id is not null THEN PERFORM im_dynfield_attribute__delete(v_attrib_id); END IF;
	alter table im_timesheet_tasks drop column if exists agile_status_id;

	v_attrib_name := 'agile_sort_order';
	select	da.attribute_id into v_attrib_id
       	from	im_dynfield_attributes da,
		acs_attributes aa
	where	da.acs_attribute_id = aa.attribute_id and
		aa.attribute_name = v_attrib_name and
		aa.object_type = 'im_timesheet_task';
	IF v_attrib_id is not null THEN PERFORM im_dynfield_attribute__delete(v_attrib_id); END IF;
	alter table im_timesheet_tasks drop column if exists agile_sort_order;

	return 0;
end;$body$ language 'plpgsql';
select inline_0 ();
drop function inline_0();

SELECT im_dynfield_widget__delete ((select widget_id from im_dynfield_widgets where widget_name = 'agile_status'));


delete from im_dynfield_type_attribute_map where object_type_id in (88000, 88010, 88020);
update im_projects set project_type_id = 2501 where project_type_id in (88000, 88010, 88020);

delete from im_category_hierarchy where parent_id in (88000, 88010, 88020);
delete from im_category_hierarchy where child_id in (88000, 88010, 88020);
delete from im_categories where category_id in (88000);
delete from im_categories where category_id in (88010);
delete from im_categories where category_id in (88020);


-- Delete all custom categories.
--
-- 88000-88999  Agile Methodologies (1000)
-- 88000-88099  Intranet Project Type extensions (100)
-- 88100-88199  Intranet Agile SCRUM States (100)
-- 88200-88299  Intranet Agile Kanban States (100)
-- 88300-88999  still free
--
delete from im_category_hierarchy where parent_id between 88000 and 88999;
delete from im_category_hierarchy where child_id between 88000 and 88999;
delete from im_categories where category_id between 88000 and 88999;


